#define INCL_WIN
#define INCL_WINWINDOWMGR
#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESS

#include <os2.h>
#include <malloc.h>
#include <string.h>

BOOL    EXPENTRY WinHookProc(HAB hab,PQMSG pqmsg,USHORT usRemove );
void    findwc(void);
BOOL    EXPENTRY HookInit(void);

int    _CRT_init(void);
void   _CRT_term(void);

HWND    hwndActive, wchwnd = 0, wlhwnd = 0;
HSWITCH hswitch = 0, wlhswitch = 0;
CURSORINFO cursorinfo;

HAB mainhab;

BOOL EXPENTRY WinHookProc(HAB hab,PQMSG pqmsg,USHORT usRemove )
{
   if ((pqmsg->msg == WM_CHAR) &&                  /* character message */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_CTRL) &&     /* CTRL not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_SHIFT) &&    /* SHIFT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_ALT) &&      /* ALT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_KEYUP) &&    /* key down */
       (SHORT1FROMMP(pqmsg->mp1) & KC_SCANCODE) && /* valid scan code */
       (CHAR4FROMMP(pqmsg->mp1) == 0x7E))  /* 'Win'95 key' left key */
   {
      /* if we don't know where the warpcenter is, find it */
      if (wchwnd == 0)
         findwc();

      /* switch to warpcenter and simulate a mouse click */
      if (wchwnd != 0)
      {
         WinSwitchToProgram(hswitch);
         WinPostMsg(wchwnd, WM_BUTTON1DOWN, MPFROM2SHORT(1,1), MPFROMLONG(0));
         WinPostMsg(wchwnd, WM_BUTTON1UP, MPFROM2SHORT(1,1), MPFROMLONG(0));
      }
   }
   if ((pqmsg->msg == WM_CHAR) &&                  /* character message */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_CTRL) &&     /* CTRL not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_SHIFT) &&    /* SHIFT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_ALT) &&      /* ALT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_KEYUP) &&    /* key down */
       (SHORT1FROMMP(pqmsg->mp1) & KC_SCANCODE) && /* valid scan code */
       (CHAR4FROMMP(pqmsg->mp1) == 0x7C))          /* 'Win'95 menu key' */
   {
	 hwndActive = WinQueryFocus(HWND_DESKTOP);
	 if (!WinQueryCursorInfo(hwndActive,&cursorinfo))
		WinPostMsg(hwndActive,
			   WM_CONTEXTMENU,
			   MPFROM2SHORT((SHORT)cursorinfo.x,(SHORT)cursorinfo.y),
			   MPFROM2SHORT(0,TRUE));
		else WinPostMsg(hwndActive,
				WM_CONTEXTMENU,
				MPFROM2SHORT(0,0),
				MPFROM2SHORT(0,FALSE));
   }

   if ((pqmsg->msg == WM_CHAR) &&                  /* character message */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_CTRL) &&     /* CTRL not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_SHIFT) &&    /* SHIFT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_ALT) &&      /* ALT not active */
      !(SHORT1FROMMP(pqmsg->mp1) & KC_KEYUP) &&    /* key down */
       (SHORT1FROMMP(pqmsg->mp1) & KC_SCANCODE) && /* valid scan code */
       (CHAR4FROMMP(pqmsg->mp1) == 0x7F))          /* 'Win'95 key' right key */
   {
   if (wlhwnd == 0) findwc();
   if (wlhwnd != 0)
      {
       WinShowWindow( wlhwnd,
                      TRUE );     /* show window. */
       WinSetFocus( HWND_DESKTOP, wlhwnd );
       WinSwitchToProgram(wlhswitch);
      }
   }
   return(FALSE);
}

/* find warpcenter window handle */
void findwc()
{
   int i,count,buffersize;
   PSWBLOCK pswblock;

   count = WinQuerySwitchList(mainhab,NULL,0);
   buffersize = count * sizeof(SWENTRY) + sizeof(ULONG);
   pswblock = (PSWBLOCK) alloca(buffersize);
   count = WinQuerySwitchList(mainhab,pswblock,buffersize);
   if (pswblock != NULL)
      for (i = 0 ; i < count ; i++) {
         if (!strcmp(pswblock->aswentry[i].swctl.szSwtitle, "WarpCenter"))
         {
            wchwnd = pswblock->aswentry[i].swctl.hwnd;
            hswitch = pswblock->aswentry[i].hswitch;
         }
         if (!strcmp(pswblock->aswentry[i].swctl.szSwtitle, "Switch to"))
         {
            wlhwnd = pswblock->aswentry[i].swctl.hwnd;
            wlhswitch = pswblock->aswentry[i].hswitch;
         }
      }
   return;
}

BOOL EXPENTRY HookInit()
{
   HMODULE hmDll;

   /* find desktop anchor */
   mainhab = WinQueryAnchorBlock(HWND_DESKTOP);

   /* setting hook */
   if(DosQueryModuleHandle("wckey", &hmDll))
      return FALSE;
   WinSetHook(mainhab, NULLHANDLE, HK_INPUT, (PFN)WinHookProc, hmDll);

   return(TRUE);
}

BOOL EXPENTRY _DLL_InitTerm(ULONG hmDll, ULONG flag)
{
   if (!flag)
      if (_CRT_init() == -1)
         return(FALSE);
   else
   {
      /* if terminating, release hook */
      WinReleaseHook(mainhab, NULLHANDLE, HK_INPUT, (PFN)WinHookProc, hmDll);
      _CRT_term();
   }
   return(TRUE);
}

